local world = require('world')

local playerWidth = 30
local playerHeight = 80
local playerSpeed = 5000
local playerMaxSpeed = 550
local playerJump = 2000

local player = {}
player.collider = world:newRectangleCollider(love.graphics.getWidth()/2, love.graphics.getHeight()/2, playerWidth, playerHeight)
player.collider:setFixedRotation(true)

function player.draw(self)
  love.graphics.setColor(0, 0.3, 1)
  x, y = self.collider:getWorldPoints(self.collider:getPoints())
  love.graphics.rectangle('fill', x, y, playerWidth, playerHeight)
end

function player.update(self, dt)
  playerMovement(self, dt)
end

function playerMovement(self, dt)
  --Not entirely sure how this works, we don't need dt?
  --dt makes everything wack?

  vx, vy = self.collider:getLinearVelocity()

  if love.keyboard.isDown("d") and vx < playerMaxSpeed then
    self.collider:applyForce(playerSpeed * dt, 0)
  end

  if love.keyboard.isDown("a") and vx > -playerMaxSpeed then
    self.collider:applyForce(-playerSpeed, 0)
  end

  if love.keyboard.isDown("w") then
    self.collider:applyLinearImpulse(0, -playerJump)
  end
end

return player
